/*
 *  ICARUS -  Interactive platform for Corpus Analysis and Research tools, University of Stuttgart
 *  Copyright (C) 2012-2013 Markus Gärtner and Gregor Thiele
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses.
 *
 * $Revision: 123 $
 * $Date: 2013-07-31 17:22:01 +0200 (Mi, 31 Jul 2013) $
 * $URL: https://subversion.assembla.com/svn/icarusplatform/trunk/Icarus/core/de.ims.icarus/source/de/ims/icarus/util/UnsupportedFormatException.java $
 *
 * $LastChangedDate: 2013-07-31 17:22:01 +0200 (Mi, 31 Jul 2013) $ 
 * $LastChangedRevision: 123 $ 
 * $LastChangedBy: mcgaerty $
 */
package de.ims.icarus.util;

/**
 * Signals that some data did not met the requirements defined
 * by some method or framework in terms of structural format.
 * For example a parser that reads data from a text-file would
 * use this exception to signal unexpected syntactical structures
 * he was unable to interpret or recognize.
 * 
 * @author Markus Gärtner 
 * @version $Id: UnsupportedFormatException.java 123 2013-07-31 15:22:01Z mcgaerty $
 *
 */
public class UnsupportedFormatException extends Exception {

	private static final long serialVersionUID = 4049528089908906476L;

	public UnsupportedFormatException() {
	}

	public UnsupportedFormatException(String message) {
		super(message);
	}

	public UnsupportedFormatException(String message, Throwable cause) {
		super(message, cause);
	}
}
