/*
 *  ICARUS -  Interactive platform for Corpus Analysis and Research tools, University of Stuttgart
 *  Copyright (C) 2012-2013 Markus Gärtner and Gregor Thiele
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses.

 * $Revision: 332 $
 * $Date: 2014-12-16 13:55:39 +0100 (Di, 16 Dez 2014) $
 * $URL: https://subversion.assembla.com/svn/icarusplatform/trunk/Icarus/core/de.ims.icarus/source/de/ims/icarus/util/transfer/DefaultConsumer.java $
 *
 * $LastChangedDate: 2014-12-16 13:55:39 +0100 (Di, 16 Dez 2014) $
 * $LastChangedRevision: 332 $
 * $LastChangedBy: mcgaerty $
 */
package de.ims.icarus.util.transfer;

import javax.swing.Icon;

import de.ims.icarus.util.Options;

/**
 * Implements a skeleton consumer that does not support batch data and
 * holds no identity information.
 *
 * @author Markus Gärtner
 * @version $Id: DefaultConsumer.java 332 2014-12-16 12:55:39Z mcgaerty $
 *
 */
public abstract class DefaultConsumer implements Consumer {

	/**
	 * @see de.ims.icarus.util.id.Identity#getId()
	 */
	@Override
	public String getId() {
		return null;
	}

	/**
	 * @see de.ims.icarus.util.id.Identity#getName()
	 */
	@Override
	public String getName() {
		return null;
	}

	/**
	 * @see de.ims.icarus.util.id.Identity#getDescription()
	 */
	@Override
	public String getDescription() {
		return null;
	}

	/**
	 * @see de.ims.icarus.util.id.Identity#getIcon()
	 */
	@Override
	public Icon getIcon() {
		return null;
	}

	/**
	 * @see de.ims.icarus.util.id.Identity#getOwner()
	 */
	@Override
	public Object getOwner() {
		return null;
	}

	/**
	 * @see de.ims.icarus.util.transfer.Consumer#processBatch(java.lang.Object[], java.lang.Object, de.ims.icarus.util.Options)
	 */
	@Override
	public void processBatch(Object[] data, Object source, Options options)
			throws Exception {
		throw new UnsupportedOperationException("Processing of batch data not supported"); //$NON-NLS-1$

	}

	/**
	 * @see de.ims.icarus.util.transfer.Consumer#supportsBatch()
	 */
	@Override
	public boolean supportsBatch() {
		return false;
	}

}
