/*
 *  ICARUS -  Interactive platform for Corpus Analysis and Research tools, University of Stuttgart
 *  Copyright (C) 2012-2013 Markus Gärtner and Gregor Thiele
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses.

 * $Revision: 352 $
 * $Date: 2015-02-23 13:26:21 +0100 (Mo, 23 Feb 2015) $
 * $URL: https://subversion.assembla.com/svn/icarusplatform/trunk/Icarus/plugins/de.ims.icarus.plugins.prosody/source/de/ims/icarus/plugins/prosody/ProsodyPlugin.java $
 *
 * $LastChangedDate: 2015-02-23 13:26:21 +0100 (Mo, 23 Feb 2015) $
 * $LastChangedRevision: 352 $
 * $LastChangedBy: mcgaerty $
 */
package de.ims.icarus.plugins.prosody;

import java.util.Collection;

import org.java.plugin.Plugin;
import org.java.plugin.registry.Extension;
import org.java.plugin.registry.ExtensionPoint;

import de.ims.icarus.Core;
import de.ims.icarus.plugins.PluginUtil;

/**
 * @author Markus Gärtner
 * @version $Id: ProsodyPlugin.java 352 2015-02-23 12:26:21Z mcgaerty $
 *
 */
public class ProsodyPlugin extends Plugin {

	/**
	 * @see org.java.plugin.Plugin#doStart()
	 */
	@Override
	protected void doStart() throws Exception {

		ensureReadme();
	}

	/**
	 * @see org.java.plugin.Plugin#doStop()
	 */
	@Override
	protected void doStop() throws Exception {
		// TODO Auto-generated method stub

	}

	private static void ensureReadme() {
		final String path = "de/ims/icarus/plugins/prosody/resources/"; //$NON-NLS-1$
		final String readmeFile = "prosody_readme.txt"; //$NON-NLS-1$
		Core.getCore().ensureResource(readmeFile, path+readmeFile, ProsodyPlugin.class.getClassLoader());
	}

	public static Collection<Extension> getProsodySentencePresenterExtensions() {
		ExtensionPoint extensionPoint = PluginUtil.getPluginRegistry().getExtensionPoint(
				ProsodyConstants.PROSODY_PLUGIN_ID, "ProsodySentencePresenter"); //$NON-NLS-1$
		return extensionPoint.getConnectedExtensions();
	}
}
