/*
 *  ICARUS -  Interactive platform for Corpus Analysis and Research tools, University of Stuttgart
 *  Copyright (C) 2012-2013 Markus Gärtner and Gregor Thiele
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses.

 * $Revision: 462 $
 * $Date: 2016-06-15 22:11:19 +0200 (Mi, 15 Jun 2016) $
 * $URL: https://subversion.assembla.com/svn/icarusplatform/trunk/Icarus/plugins/de.ims.icarus.plugins.search_tools/source/de/ims/icarus/search_tools/standard/AbstractSearchFactory.java $
 *
 * $LastChangedDate: 2016-06-15 22:11:19 +0200 (Mi, 15 Jun 2016) $
 * $LastChangedRevision: 462 $
 * $LastChangedBy: mcgaerty $
 */
package de.ims.icarus.search_tools.standard;

import de.ims.icarus.plugins.search_tools.view.editor.QueryEditor;
import de.ims.icarus.search_tools.ConstraintContext;
import de.ims.icarus.search_tools.Search;
import de.ims.icarus.search_tools.SearchFactory;
import de.ims.icarus.search_tools.SearchManager;
import de.ims.icarus.search_tools.SearchQuery;
import de.ims.icarus.ui.helper.Editor;
import de.ims.icarus.util.Options;

/**
 * @author Markus Gärtner
 * @version $Id: AbstractSearchFactory.java 462 2016-06-15 20:11:19Z mcgaerty $
 *
 */
public abstract class AbstractSearchFactory implements SearchFactory {

	@Override
	public Search createExampleSearch() throws Exception {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Editor<Options> createParameterEditor() {
		return new DefaultParameterEditor();
	}

	@Override
	public Class<? extends QueryEditor> getDefaultEditorClass() {
		return null;
	}

	@Override
	public String getQueryLabel(SearchQuery query) {
		return null;
	}

	/**
	 * @see de.ims.icarus.search_tools.SearchFactory#createQuery()
	 */
	@Override
	public SearchQuery createQuery() {
		ConstraintContext constraintContext = SearchManager.getInstance().getConstraintContext(getContentType());
		return new DefaultSearchQuery(constraintContext);
	}
}
