/*
 *  ICARUS -  Interactive platform for Corpus Analysis and Research tools, University of Stuttgart
 *  Copyright (C) 2012-2013 Markus Gärtner and Gregor Thiele
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses.
 *
 * $Revision: 384 $
 * $Date: 2015-04-09 23:45:04 +0200 (Do, 09 Apr 2015) $
 * $URL: https://subversion.assembla.com/svn/icarusplatform/trunk/Icarus/plugins/de.ims.icarus.plugins.search_tools/source/de/ims/icarus/search_tools/standard/ConstraintAdapter.java $
 *
 * $LastChangedDate: 2015-04-09 23:45:04 +0200 (Do, 09 Apr 2015) $
 * $LastChangedRevision: 384 $
 * $LastChangedBy: mcgaerty $
 */
package de.ims.icarus.search_tools.standard;

import javax.xml.bind.annotation.adapters.XmlAdapter;

import de.ims.icarus.search_tools.SearchConstraint;


/**
 * @author Markus Gärtner
 * @version $Id: ConstraintAdapter.java 384 2015-04-09 21:45:04Z mcgaerty $
 *
 */
public class ConstraintAdapter extends XmlAdapter<DefaultConstraint, SearchConstraint> {

	/**
	 * @see javax.xml.bind.annotation.adapters.XmlAdapter#unmarshal(java.lang.Object)
	 */
	@Override
	public SearchConstraint unmarshal(DefaultConstraint v) throws Exception {
		return v;
	}

	/**
	 * @see javax.xml.bind.annotation.adapters.XmlAdapter#marshal(java.lang.Object)
	 */
	@Override
	public DefaultConstraint marshal(SearchConstraint v) throws Exception {
		return (v instanceof DefaultConstraint) ? (DefaultConstraint)v :  new DefaultConstraint(v);
	}

}
