package ims.gw;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class GWClean {

	public static void main(String[] args) throws IOException, ParserConfigurationException, SAXException{
		Options options=new Options(args);
		SAXParserFactory factory = SAXParserFactory.newInstance();
		SAXParser saxParser = factory.newSAXParser();
		InputStream is=Util.getEnclosedInputStream(options.input, options.gzippedIn,"rrooottt");
		InputSource source=new InputSource(new InputStreamReader(is,options.inputEnc));
		source.setEncoding(options.inputEnc);
		final AbstractDefaultHandler handler;
		switch(options.mode){
		case Stats: handler=new StatsHandler(options); break;
		case Clean: handler=new CleanAndTokenize(options); break;
		default: throw new RuntimeException("not implemented");
		}
		saxParser.parse(source, handler);
		handler.finish();
	}
	
}
