package ims.gw;

import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class StatsHandler extends AbstractDefaultHandler{

	StatsHandler(Options options) throws IOException {
		super(options);
	}

	private Map<String,MutableInt> docTypeCounts=new TreeMap<String,MutableInt>();
	private Map<String,MutableInt> beginTokenCount=new TreeMap<String,MutableInt>();
	private Map<String,MutableInt> endTokenCount=new TreeMap<String,MutableInt>();
	private Map<Character,MutableInt> charCount=new TreeMap<Character,MutableInt>();
	
		
	void handleParagraph(List<List<String>> asStrings){
		for (List<String> sentence : asStrings) {
			Util.incrementMapValue(beginTokenCount, sentence.get(0).toString());
			Util.incrementMapValue(endTokenCount, sentence.get(sentence.size()-1).toString());
			for(String hw:sentence){
				String s=hw.toString();
				keepTokenCount++;
				for(int j=0;j<s.length();++j){
					Character c=s.charAt(j);
					Util.incrementMapValue(charCount, c);
				}
			}
		}
	}

	@Override
	void startDoc(String docType) {
		Util.incrementMapValue(docTypeCounts, docType);
	}

	@Override
	protected void subclassFinish() {
		System.err.println("BOS words:");
		for(String s:beginTokenCount.keySet())
			System.err.printf("%-25s %8d\n", s, beginTokenCount.get(s).getValue());
		System.err.println();
		System.err.println("---------------");
		System.err.println("EOS words:");
		for(String s:endTokenCount.keySet())
			System.err.printf("%-25s %8d\n", s, endTokenCount.get(s).getValue());
		
		System.err.println();
		System.err.println("---------------");
		System.err.println("Char counts:");
		for(Character c:charCount.keySet())
			System.err.printf("%-2s     %8d\n",c,charCount.get(c).getValue());
		
		System.err.println();
	}
	
}
