package ims.gw;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Map;
import java.util.zip.GZIPInputStream;


public class Util {

	public static InputStream getEnclosedInputStream(File f,boolean gzipped,String rootQName) throws IOException{
		InputStream is;
		if(f==null)
			is=System.in;
		else
			is=new FileInputStream(f);
		if(gzipped)
			is=new GZIPInputStream(is);
		if(rootQName==null)
			return is;
		else {
			String pre="<"+rootQName+">";
			String post="</"+rootQName+">";
			return new EnclosedInputStream(pre.getBytes(),is,post.getBytes());
		}
			
	}

	public static <T> void incrementMapValue(Map<T,MutableInt> tm, T key){
		MutableInt mi=tm.get(key);
		if(mi==null){
			tm.put(key,new MutableInt(1));
		} else {
			mi.increment();
		}
	}
}
