package is2.io;

import java.util.ArrayList;

import ims.nbest.LabeledParse;
import is2.data.SentenceData09;

public class D8NBestCONLLReader09 extends CONLLReader09 {
	
	public D8NBestCONLLReader09(String outfile, int i) {
		super(outfile,i);
	}

	public NBestSentenceData09 getNextCoNLL09()  {

		String line=null;
		int i=0;
		try {

			ArrayList<String[]> lineList = new ArrayList<String[]>();

			line = inputReader.readLine();
			lineNumber++;

			while(line !=null && line.length()==0) {
				line = inputReader.readLine();
				lineNumber++;
				System.out.println("skip empty line at line "+lineNumber);
			} 

			while (line != null && line.length()!=0 &&  !line.startsWith(STRING) &&!line.startsWith(REGEX) && !line.startsWith("ParseNBest")) {
				lineList.add(line.split(REGEX));
				line = inputReader.readLine();
				lineNumber++;
			}



			int length = lineList.size();

			if(length == 0) {
				inputReader.close();
				return null;
			}

			NBestSentenceData09 it = new NBestSentenceData09();

			it.forms = new String[length+1];

			it.plemmas = new String[length+1];
			//	it.ppos = new String[length+1];
			it.gpos = new String[length+1];
			it.labels = new String[length+1];
			it.heads = new int[length+1];
			it.pheads = new int[length+1];
			it.plabels = new String[length+1];

			it.ppos = new String[length+1];
			it.lemmas = new String[length+1];
			it.fillp = new String[length+1];
			it.feats = new String[length+1][];
			it.ofeats = new String[length+1];
			it.pfeats = new String[length+1];
			it.id = new String[length+1];

			it.forms[0] = ROOT;
			it.plemmas[0] = ROOT_LEMMA;
			it.fillp[0] = "N";
			it.lemmas[0] = ROOT_LEMMA;

			it.gpos[0] = ROOT_POS;
			it.ppos[0] = ROOT_POS;
			it.labels[0] = NO_TYPE;
			it.heads[0] = -1;
			it.plabels[0] = NO_TYPE;
			it.pheads[0] = -1;
			it.ofeats[0] = NO_TYPE;
			it.id[0] ="0";

			// root is 0 therefore start with 1

			for(i = 1; i <= length; i++) {
				
				
				
				String[] info = lineList.get(i-1);

				it.id[i] = info[0];
				it.forms[i] = info[1]; //normalize(
				if (info.length<3) continue;

				it.lemmas[i] = info[2];
				it.plemmas[i] =info[3]; 
				it.gpos[i] = info[4];  

				if (info.length<5) continue;
				it.ppos[i] = info[5];//.split("\\|")[0];
				// feat 6
	
	
				// now we try underscore
				it.ofeats[i]=info[6].equals(CONLLWriter09.DASH)? "_" : info[6];

				if (joint.length()>0) {
					
					StringBuilder b = new StringBuilder();
//					b.append(it.gpos[i]);
					if (joint.startsWith("cz")) {
						
					//	boolean caseFound =false;
				
						String [] split = it.ofeats[i].split(PIPE);
				//		if (!caseFound)
						for(String s : split) {
							if (s.startsWith("SubPOS")) {
								if (b.length()>0 )b.append("|");
								b.append(s);
							}
						}
					
						for(String s : split) {
							if (s.startsWith("Cas")){
								if (b.length()>0 )b.append("|");
								b.append(s);
							}
						
						}

//						for(String s : split) {
//							if (s.startsWith("Num")) {
//								if (b.length()>0 )b.append("|");
//								b.append(s);
//							}
//						}

				
						
					} else if (joint.contains("ger")) {
					
						String [] split = it.ofeats[i].split(PIPE);
						for(String s : split) { 
							if ( s.matches("Nom|Acc|Dat|Gen")) {
								if (b.length()>0 )b.append("|");
								b.append(s);
							}
							if ( s.matches("Sg|Pl")) {
								if (b.length()>0 )b.append("|");
								b.append(s);
							}
						}
						
					} else {
						String [] split = it.ofeats[i].split(PIPE);
						for(String s : split) 
							if ( s.matches(joint)) b.append("|").append(s);
					}
					if (b.length()==0)b.append("_");
					it.ofeats[i] = b.toString();
				}
				
				if (info[7].equals(CONLLWriter09.DASH)) it.feats[i]=null;
				else {
					it.feats[i] =info[7].split(PIPE);
					it.pfeats[i] = info[7];
				}

				
				
				if (info[8].equals(US))it.heads[i]=-1;
				else it.heads[i] = Integer.parseInt(info[8]);// head
	
				it.pheads[i]=info[9].equals(US) ? it.pheads[i]=-1:  Integer.parseInt(info[9]);// head

				it.labels[i] = info[10];					
				it.plabels[i] = info[11];
				it.fillp[i]=info[12];

				if (info.length>13) {
					if (!info[13].equals(US)) it.addPredicate(i,info[13]);
					for(int k=14;k<info.length;k++)  it.addArgument(i,k-14,info[k]);

				}




			}
			if(line.startsWith("ParseNBest")){
				String[] fields=line.split("\t");
				String[] treesCompact=fields[3].split("\\];\\[");
				if(fields.length!=4 || treesCompact.length!=Integer.parseInt(fields[2]))
					throw new Exception("failed to parse nbest line: "+line);
				treesCompact[0]=treesCompact[0].replaceFirst("\\[", "");
				treesCompact[treesCompact.length-1]=treesCompact[treesCompact.length-1].replaceFirst("\\]$", "");
				it.parses=new LabeledParse[treesCompact.length];
				for(int k=0;k<treesCompact.length;++k)
					it.parses[k]=string2LabeledParse(treesCompact[k]);
				if(!(line = inputReader.readLine()).equals(""))
					throw new Exception("next line not blank");
			} else {
				throw new Exception("last line is not ParseNBest line");
			}
			return it;

		} catch(Exception e) {
			System.out.println("\n!!! Error in input file sentence before line: "+lineNumber+" (in sentence line "+i+" ) "+e.toString());
			e.printStackTrace();
			System.exit(0);
			
			return null;
		}

	}
	
	private LabeledParse string2LabeledParse(String s) {
		String[] a=s.split(" ");
		float score=Float.parseFloat(a[0]);
		short[] heads=new short[a.length-1];
		String[] lbls=new String[a.length-1];
		for(int i=1,q=0;i<a.length;++i,++q){
			String[] b=a[i].split(",");
			heads[q]=Short.parseShort(b[0]);
			lbls[q]=b[1];
		}
		return new LabeledParse(heads, lbls, score);
	}

	public static class NBestSentenceData09 extends SentenceData09 {
		public LabeledParse[] parses;
	}
}
