package is2.io;

import is2.data.Parse;

import java.io.IOException;
import java.util.List;

public class D8NBestCONLLWriter09 extends CONLLWriter09 {

	public D8NBestCONLLWriter09(String outfile, int formatTask) {
		super(outfile,formatTask);
	}

	public void writeNBest(List<? extends Parse> nBest, String[] _types) throws IOException {
		int total=nBest.size();
		StringBuilder prefix=new StringBuilder("ParseNBest\tAnnaD8\t");
		prefix.append(total).append('\t');
		writer.write(prefix.toString());
		int m=nBest.size()-1;
		for(int i=0;i<m;++i){
			String s=parse2String(nBest.get(i),_types);
			writer.write(s);
			writer.write(";");
		}
		writer.write(parse2String(nBest.get(m),_types));
		writer.newLine();
		writer.newLine();
	}
	
	private String parse2String(Parse p,String[] _types) {
		StringBuilder sb=new StringBuilder("[");
		sb.append(p.f1).append(" ");
		for(int i=0;i<p.heads.length-1;++i)
			sb.append(p.heads[i]).append(',').append(_types[p.labels[i]]).append(' ');
		sb.append(p.heads[p.heads.length-1]).append(',').append(_types[p.labels[p.heads.length-1]]).append(']');
		return sb.toString();
	}

	public void newLine() throws IOException{
		writer.newLine();
	}

}
