package is2.parser;

import java.util.List;
import java.util.concurrent.Callable;

import is2.data.DataFES;

public class ParallelRearrangeNBestD8 implements Callable<Void> {

	private final short[] pos; //Remains fixed
	private final DataFES x;
	private final SyncJobQueue jobQueue;
	
	private final short[] heads; //changes
	private final short[] labs;  //changes

	public ParallelRearrangeNBestD8(short[] pos,short[] heads, short[] labs,DataFES x,SyncJobQueue jq){
		this.pos=pos;
		this.heads=heads;
		this.labs=labs;
		this.x=x;
		this.jobQueue=jq;
	}
	
	static class RearrangeJob {
		final short ch,pa;
		float[] outScores;
		short[] outLabs;
		public RearrangeJob(short pa,short ch){
			this.ch=ch;
			this.pa=pa;
		}
	}
	
	static class SyncJobQueue {
		private final List<RearrangeJob> jobs;
		public SyncJobQueue(List<RearrangeJob> jobs){
			this.jobs=jobs;
		}
		public synchronized RearrangeJob nextJob(){
			if(jobs.size()==0)
				return null;
			return jobs.remove(jobs.size()-1);
		}
	}

	@Override
	public Void call() throws Exception {
		RearrangeJob j;
		while((j=jobQueue.nextJob())!=null){
			short ch=j.ch;
			short oldPa=heads[ch];
			short oldLab=labs[ch];
			short pa=j.pa;
			j.outLabs  = Edges.get(pos[pa], pos[ch]);
			j.outScores=new float[j.outLabs.length];
			heads[ch]=pa;
			//compute scores
			for(int q=0;q<j.outLabs.length;++q){
				short l=j.outLabs[q];
				labs[ch]=l;
				j.outScores[q]=Extractor.encode3(pos, heads, labs, x);
			}
			//reset head
			heads[ch]=oldPa;
			labs[ch]=oldLab;
		}
		return null;
	}
	
	
}
