/*
 *  ICARUS -  Interactive platform for Corpus Analysis and Research tools, University of Stuttgart
 *  Copyright (C) 2012-2013 Markus Gärtner and Gregor Thiele
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses.
 *
 * $Revision: 465 $
 * $Date: 2016-09-23 18:26:03 +0200 (Fr, 23 Sep 2016) $
 * $URL: https://subversion.assembla.com/svn/icarusplatform/trunk/Icarus/plugins/de.ims.icarus.plugins.coref/source/de/ims/icarus/language/coref/CoreferenceData.java $
 *
 * $LastChangedDate: 2016-09-23 18:26:03 +0200 (Fr, 23 Sep 2016) $
 * $LastChangedRevision: 465 $
 * $LastChangedBy: mcgaerty $
 */
package de.ims.icarus.language.coref;

import de.ims.icarus.language.SentenceData;
import de.ims.icarus.util.CompactProperties;

/**
 * @author Markus Gärtner
 * @version $Id: CoreferenceData.java 465 2016-09-23 16:26:03Z mcgaerty $
 *
 */
public interface CoreferenceData extends SentenceData {

	public static final String SPEAKER_PROPERTY = "speaker"; //$NON-NLS-1$
	public static final String PHRASE_TREE_PROPERTY = "phraseTree"; //$NON-NLS-1$
	public static final String SENTENCE_ID_PROPERTY = "sentenceId"; //$NON-NLS-1$
	public static final String DOCUMENT_ID_PROPERTY = "documentId"; //$NON-NLS-1$
	public static final String PART_ID_PROPERTY = "partId"; //$NON-NLS-1$

	/**
	 * Fetches a general property of this sentence
	 */
	@Override
	Object getProperty(String key);

	/**
	 * Fetches a property that was assigned for a certain word in
	 * this sentence
	 */
	@Override
	Object getProperty(int index, String key);

	// NOTE: spans should always be sorted descending in order of size!
	Span[] getSpans();

	DocumentData getDocument();

	CompactProperties getProperties();
}
