/*
 *  ICARUS -  Interactive platform for Corpus Analysis and Research tools, University of Stuttgart
 *  Copyright (C) 2012-2013 Markus Gärtner and Gregor Thiele
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses.
 *
 * $Revision: 224 $
 * $Date: 2014-02-10 13:35:28 +0100 (Mo, 10 Feb 2014) $
 * $URL: https://subversion.assembla.com/svn/icarusplatform/trunk/Icarus/plugins/de.ims.icarus.plugins.coref/source/de/ims/icarus/plugins/coref/view/grid/labels/GridLabelBuilder.java $
 *
 * $LastChangedDate: 2014-02-10 13:35:28 +0100 (Mo, 10 Feb 2014) $
 * $LastChangedRevision: 224 $
 * $LastChangedBy: mcgaerty $
 */
package de.ims.icarus.plugins.coref.view.grid.labels;

import de.ims.icarus.language.coref.Span;
import de.ims.icarus.plugins.coref.view.grid.EntityGridNode;

/**
 * @author Markus Gärtner
 * @version $Id: GridLabelBuilder.java 224 2014-02-10 12:35:28Z mcgaerty $
 *
 */
public interface GridLabelBuilder {

	/**
	 * Create a textual representation of the {@link Span} at
	 * index {@code spanIndex} of the given {@link EntityGridNode}.
	 */
	public String getLabel(EntityGridNode node, int spanIndex);
}
