/*
 *  ICARUS -  Interactive platform for Corpus Analysis and Research tools, University of Stuttgart
 *  Copyright (C) 2012-2013 Markus Gärtner and Gregor Thiele
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses.

 * $Revision: 332 $
 * $Date: 2014-12-16 13:55:39 +0100 (Di, 16 Dez 2014) $
 * $URL: https://subversion.assembla.com/svn/icarusplatform/trunk/Icarus/plugins/de.ims.icarus.plugins.search_tools/source/de/ims/icarus/search_tools/SearchResultExportHandler.java $
 *
 * $LastChangedDate: 2014-12-16 13:55:39 +0100 (Di, 16 Dez 2014) $
 * $LastChangedRevision: 332 $
 * $LastChangedBy: mcgaerty $
 */
package de.ims.icarus.search_tools;

import de.ims.icarus.search_tools.result.SearchResult;
import de.ims.icarus.util.ToolException;

/**
 * @author Markus Gärtner
 * @version $Id: SearchResultExportHandler.java 332 2014-12-16 12:55:39Z mcgaerty $
 *
 */
public interface SearchResultExportHandler {

	/**
	 * Initiate export of the given {@code SearchResult}. It is up to
	 * the export handler to ask the user for target location and the
	 * details on how to format/organize the result. Note that this
	 * method is called on the <i>event-dispatch-thread</i>.
	 */
	void exportResult(SearchResult searchResult) throws ToolException;
}
